%global gtk3_version 3.19.8
%global glib_version 2.53.2
%global gobject_introspection_version 1.41.0
%global gsettings_desktop_schemas_version 3.21.4
%global json_glib_version 0.12.0
%global libinput_version 1.4
%global pipewire_version 0.2.2

Name:           mutter328
Version:        3.28.4
Release:        3%{?dist}
Summary:        Window and compositing manager based on Clutter
License:        GPLv2+

URL:            http://www.gnome.org
Source0:        http://download.gnome.org/sources/mutter/3.28/mutter-%{version}.tar.xz

# These patches are all from the latest mutter-3-28 branch, plus:
# - workaround for non-working startup notifications on wayland
# - porting to libpipewire-0.2
# - porting to gnome-settings-daemon and gsettings-desktop-schemas 3.32
# The patch-set has been generated using git format-patch.

# patches from gnome-3-28 branch
Patch0:         0000-cursor-renderer-native-Free-MetaCursorNativePrivate-.patch
Patch1:         0001-wayland-seat-Use-g_free-to-cleanup-MetaWaylandSeat.patch
Patch2:         0002-cogl-pipeline-Don-t-try-to-access-to-free-d-pointer-.patch
Patch3:         0003-workspace-Focus-only-ancestors-that-are-focusable.patch
Patch4:         0004-tests-Add-accept_focus-command-to-runner-and-client.patch
Patch5:         0005-tests-Add-can_take_focus-command-to-runner-and-clien.patch
Patch6:         0006-tests-stacking-Add-tests-with-no-input-and-no-take-f.patch
Patch7:         0007-test-runner-Add-assert_focused-command.patch
Patch8:         0008-tests-Verify-focused-window-in-closed-transient-test.patch
Patch9:         0009-test-runner-Add-sleep-command.patch
Patch10:        0010-test-runner-Add-dispatch-command.patch
Patch11:        0011-window-x11-Focus-the-default-window-with-delay-while.patch
Patch12:        0012-window-Emit-an-error-and-return-when-trying-to-activ.patch
Patch13:        0013-window-x11-Don-t-double-check-for-unmanaging-windows.patch
Patch14:        0014-window-x11-Accept-any-focusable-window-as-fallback-f.patch
Patch15:        0015-stack-Add-a-function-to-get-a-sorted-list-of-focus-c.patch
Patch16:        0016-window-x11-Use-any-focusable-window-as-fallback-dela.patch
Patch17:        0017-screen-Destroy-window-actors-after-windows-while-unm.patch
Patch18:        0018-screen-Unset-the-active-workspace-and-remove-workspa.patch
Patch19:        0019-monitor-manager-use-MonitorsConfig-to-track-switch_c.patch
Patch20:        0020-monitor-manager-Don-t-use-switch-config-when-ensurin.patch

# workaround for non-working startup notifications on wayland
Patch21:        0021-wayland-gtk-shell-Work-around-non-working-startup-no.patch

# port to libpipewire-0.2
Patch22:        0022-backends-screen-cast-support-libpipewire-0.2.patch

# port to gnome-settings-daemon and gsettings-desktop-schemas 3.32
Patch23:        0023-clutter-Add-API-to-retrieve-the-physical-size-of-abs.patch
Patch24:        0024-backends-Add-MetaInputMapper.patch
Patch25:        0025-backends-Delegate-on-MetaInputMapper-for-unmapped-di.patch
Patch26:        0026-backends-Add-MetaInputMapper-method-to-lookup-device.patch
Patch27:        0027-backends-Turn-builtin-touchscreen-on-off-together-wi.patch
Patch28:        0028-backends-Update-to-new-output-setting-for-tablets-to.patch

BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  desktop-file-utils
BuildRequires:  gnome-common
BuildRequires:  gtk-doc
BuildRequires:  intltool
BuildRequires:  libtool
BuildRequires:  zenity

BuildRequires:  gettext-devel
BuildRequires:  pam-devel

BuildRequires:  pkgconfig(cairo) >= 1.10.0
BuildRequires:  pkgconfig(egl)
BuildRequires:  pkgconfig(gbm)
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(glesv2)
BuildRequires:  pkgconfig(gio-unix-2.0) >= %{glib_version}
BuildRequires:  pkgconfig(glib-2.0) >= %{glib_version}
BuildRequires:  pkgconfig(gnome-desktop-3.0)
BuildRequires:  pkgconfig(gobject-introspection-1.0) >= %{gobject_introspection_version}
BuildRequires:  pkgconfig(gsettings-desktop-schemas) >= %{gsettings_desktop_schemas_version}
BuildRequires:  pkgconfig(gtk+-3.0) >= %{gtk3_version}
BuildRequires:  pkgconfig(gudev-1.0)
BuildRequires:  pkgconfig(json-glib-1.0) >= %{json_glib_version}
BuildRequires:  pkgconfig(libcanberra)
BuildRequires:  pkgconfig(libdrm)
BuildRequires:  pkgconfig(libinput)
BuildRequires:  pkgconfig(libpipewire-0.2) >= %{pipewire_version}
BuildRequires:  pkgconfig(libstartup-notification-1.0)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(libwacom)
BuildRequires:  pkgconfig(pango) >= 1.2.0
BuildRequires:  pkgconfig(pangoft2)
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(systemd)
BuildRequires:  pkgconfig(upower-glib) >= 0.99.0
BuildRequires:  pkgconfig(wayland-server)
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xcb)
BuildRequires:  pkgconfig(xcomposite) >= 0.2
BuildRequires:  pkgconfig(xcursor)
BuildRequires:  pkgconfig(xdamage)
BuildRequires:  pkgconfig(xext)
BuildRequires:  pkgconfig(xfixes)
BuildRequires:  pkgconfig(xi) >= 1.6.0
BuildRequires:  pkgconfig(xkbcommon) >= 0.4.3
BuildRequires:  pkgconfig(xkbcommon-x11)
BuildRequires:  pkgconfig(xkbfile)
BuildRequires:  pkgconfig(xkeyboard-config)
BuildRequires:  pkgconfig(xrandr)
BuildRequires:  pkgconfig(xrender)
BuildRequires:  pkgconfig(xtst)

Obsoletes:      mutter-wayland < 3.13.0
Obsoletes:      mutter-wayland-devel < 3.13.0

# Make sure yum updates gnome-shell as well; otherwise we might end up with
# broken gnome-shell installations due to mutter ABI changes.
Conflicts:      gnome-shell < 3.21.1

# Conflict with the main mutter package
Conflicts:      mutter >= 3.29.4

Requires:       control-center-filesystem
Requires:       dbus-x11
Requires:       gsettings-desktop-schemas%{?_isa} >= %{gsettings_desktop_schemas_version}
Requires:       gtk3%{?_isa} >= %{gtk3_version}
Requires:       pipewire%{?_isa} >= %{pipewire_version}
Requires:       startup-notification
Requires:       zenity

Requires:       json-glib%{?_isa} >= %{json_glib_version}
Requires:       libinput%{?_isa} >= %{libinput_version}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description
Mutter is a window and compositing manager that displays and manages
your desktop via OpenGL. Mutter combines a sophisticated display engine
using the Clutter toolkit with solid window-management logic inherited
from the Metacity window manager.

While Mutter can be used stand-alone, it is primarily intended to be
used as the display core of a larger system such as GNOME Shell. For
this reason, Mutter is very extensible via plugins, which are used both
to add fancy visual effects and to rework the window management
behaviors to meet the needs of the environment.


%package        libs
Summary:        Shared libraries for %{name}

Requires:       mutter%{?_isa} >= 3.29.4
Conflicts:      mutter%{?_isa} < 3.29.4

%description    libs
Shared libraries for Mutter.


%package        devel
Summary:        Development package for %{name}

Requires:       %{name}-libs%{?_isa} = %{version}-%{release}
Conflicts:      mutter-devel%{?_isa}

%description    devel
Header files and libraries for developing Mutter plugins. Also includes
utilities for testing Metacity/Mutter themes.


%package        tests
Summary:        Tests for the %{name} package

Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}
Conflicts:      mutter-tests%{?_isa}

%description tests
The %{name}-tests package contains tests that can be used to verify
the functionality of the installed %{name} package.


%prep
%autosetup -n mutter-%{version} -p1


%build
autoreconf -f -i

%configure \
    --disable-static \
    --enable-compile-warnings=maximum \
    --enable-remote-desktop \
    --enable-installed-tests \
    --with-libwacom

%make_build


%install
%make_install

%find_lang mutter

# remove libtool archives
find %{buildroot} -name "*.la" -print -delete


%check
desktop-file-validate \
    %{buildroot}/%{_datadir}/applications/mutter.desktop


%ldconfig_scriptlets libs


%files -f mutter.lang
%{_bindir}/mutter

%{_libexecdir}/mutter-restart-helper

%{_libdir}/mutter/plugins/

%{_datadir}/applications/*.desktop
%{_datadir}/GConf/gsettings/mutter-schemas.convert
%{_datadir}/glib-2.0/schemas/org.gnome.mutter.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.mutter.wayland.gschema.xml
%{_datadir}/gnome-control-center/keybindings/50-mutter-*.xml

%{_mandir}/man1/mutter.1*

%files libs
%license COPYING
%doc NEWS

%{_libdir}/lib*.so.*
%{_libdir}/mutter/

%exclude %{_libdir}/mutter/plugins

%files devel
%{_includedir}/*
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*

%files tests
%{_libexecdir}/installed-tests/mutter
%{_libexecdir}/installed-tests/mutter-clutter
%{_libexecdir}/installed-tests/mutter-cogl

%{_datadir}/installed-tests/mutter
%{_datadir}/installed-tests/mutter-clutter
%{_datadir}/installed-tests/mutter-cogl
%{_datadir}/mutter/tests


%changelog
* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 3.28.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Sun Jul 21 2019 Kalev Lember <klember@redhat.com> - 3.28.4-2
- Rebuilt for libgnome-desktop soname bump

* Tue Jul 16 2019 Fabio Valentini <decathorpe@gmail.com> - 3.28.4-1
- Rebase on top of 3.28.4 and the gnome-3-28 branch again.

* Tue Apr 23 2019 Fabio Valentini <decathorpe@gmail.com> - 3.28.3-7
- Include all patches from the gnome-3-28 branch.
- Backport support for gnome-settings-daemon and gsettings-desktop-schemas 3.32.

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 3.28.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Wed Oct 17 2018 Fabio Valentini <decathorpe@gmail.com> - 3.28.3-5
- Forward-port patchset from current mutter on fedora 28.

* Sun Sep 09 2018 Fabio Valentini <decathorpe@gmail.com> - 3.28.3-4
- Initial compat package of mutter 3.28.

